<script>
    function csvJSON(csv) {
           const lines = csv.split('\r\n')
           const result = []
           const headers = lines[0].split(',')

           for (let i = 1; i < lines.length; i++) {        
               if (!lines[i])
                   continue
               const obj = {}
               const currentline = lines[i].split(',')

               for (let j = 0; j < headers.length; j++) {
                   obj[headers[j]] = currentline[j]
               }
               result.push(obj)
           }
           return result
       }



       var fetchAndAppend = async (url, parent) => {
           var res = await fetch(url);
           
           var body = await res.text()
           var headers = res.headers;
           // 'Content-Disposition' = attachment; filename="billionaires-states2.csv"; filename*=UTF-8''billionaires%20-%20states2.csv
           // console.log(headers.get('Content-Disposition').split(';').find(d => d.indexOf("filename=") > -1)?.split("=")[1])
           var filename = headers.get('Content-Disposition').split(';').find(d => d.indexOf("filename=") > -1)?.split("=")[1]
               filename = filename.replaceAll('"', '').replaceAll("-","/").replaceAll(".csv", '')
           var json = csvJSON(body);
               json = json.sort((a, b) => (a.order==b.order?0:(a.order>b.order?-1:1)))
           if(json.length <= 0){
               console.log("could not load --> %o", url)
               document.body.innerHTML += `Could not load <a href=${url}>${url}</a>`;
           }
           console.log(json)

           var list = createlist();
           updatelist(list, json)
           parent.appendChild(list);
           
           var link = create('a');
           link.href = `${url.replace("/pub", "/edit")}`
           link.innerText = filename?filename:"Source"
           parent.appendChild(link);
       }
</script>

<script>
   (async() =>{    
       var masterurl = "https://docs.google.com/spreadsheets/d/1oZscU3kPbngnpgCvP05WK85H7ss5Spl6aui5hT8OjF8/pub?gid=2093340940"
           masterurl += "&output=csv";
       var masterres = await fetch(masterurl);
       var masterbody = await masterres.text()
       console.log(masterbody)
       var masterjson = csvJSON(masterbody);

       var csvfiles = masterjson.filter(d => d.ENABLED == "TRUE").map(d => d.URL + "&output=csv").map(d => d.replace("/edit", "/pub"));
       console.log(csvfiles);
       
       csvfiles.forEach( csvfile => {
           var body = document.getElementsByTagName('body').item(0);
           var span = create('span');
           body.appendChild(span);
           fetchAndAppend(csvfile, span);
       })
       
       // (async(urls) =>{
       //     urls.forEach( fetchAndAppend )
       // })(csvfiles)
   })()
</script>


<style>
   td{background-color: floralwhite;}
   .disable-dbl-tap-zoom {
     touch-action: manipulation;
   }

</style>

<script>
 let create = (tag, text) => { var el = document.createElement(tag); if(text){el.innerText = text;} return el};
 let due = (questions) => questions.filter(d => !d.STATUS.includes("OVERDUE")).filter(d => d.STATUS.includes("DUE"));
 let overdue = (questions) => questions.filter(d => d.STATUS.includes("OVERDUE"));
   //   let questionslist = (questions) => due(questions).concat(fresh(questions));
   let questionslist = (questions) => due(questions).concat(overdue(questions));
 let createlist = () => { return create('ol');}
 let updatelist = (list, questions) => {list.replaceChildren(); questionslist(questions).forEach(d => {var li = document.createElement('li'); li.innerText = `${d.Q} ${d.STATUS ? `(${d.DUEINDAYS})  `: ""}`; li.appendChild(answerlink(d.A));/*var textarea = document.createElement('input'); textarea.type="text"; li.appendChild(textarea); */ list.appendChild(li); return list; })}
 let answerlink = (answer) => { var l = create('a', "..."); l.id="a123"; l['href']="javascript:void(0);"; l.addEventListener('click', (event) => {event.currentTarget.innerText = `${answer}`}); return l;} 
</script>


<hr/>

<ol id = "due-overdue">

</ol>

